;;;; -*- Mode:Common-Lisp; Package:USER; Fonts:(MEDFNT); Base:10 -*-

;;;; **************************************************************************
;;;; **************************************************************************
;;;; *                                                                        *
;;;; *                           Load File for CLASP                          *
;;;; *                                                                        *
;;;; **************************************************************************
;;;; **************************************************************************
;;;
;;; Copyright (c) 1990 - 1994 University of Massachusetts
;;; Department of Computer Science
;;; Experimental Knowledge Systems Laboratory
;;; Professor Paul Cohen, Director.
;;; All rights reserved.

;;; Permission to use, copy, modify and distribute this software and
;;; its documentation is hereby granted without fee for non-commercial
;;; uses only (not for resale), provided that the above copyright
;;; notice of EKSL, this paragraph and the one following appear in all
;;; copies and in supporting documentation.

;;; EKSL makes no representation about the suitability of this software for any
;;; purposes.  It is provided "AS IS", without express or implied warranties
;;; including (but not limited to) all implied warranties of merchantability
;;; and fitness for a particular purpose, and notwithstanding any other
;;; provision contained herein.  In no event shall EKSL be liable for any
;;; special, indirect or consequential damages whatsoever resulting from loss
;;; of use, data or profits, whether in an action of contract, negligence or
;;; other tortuous action, arising out of or in connection with the use or
;;; performance of this software, even if EKSL is advised of the possiblity of
;;; such damages.

(in-package #-MCL :USER #+MCL COMMON-LISP-USER)

;;; --*--
;;; ***************************************************************************

(flet ((load-sibling (name)
	 (load (merge-pathnames name  
				#+lucid lcl:*source-pathname*
				#+allegro excl:*source-pathname*
				#+(or Genera Explorer) sys:fdefine-file-pathname
				#-(or lucid allegro Genera Explorer)
				*load-pathname*))))
  #-eksl-generic-load-utils
  (load-sibling "generic-load-utils")
  (load-sibling "load-common"))

;;;----------------------------------------------------------------------------
;;; Load-time stuff

(setf *clasp-load-layers* t)
(setf *clasp-load-fbd* t)
(setf *clasp-load-msdd* t)
(setf *clasp-load-imsdd* t)

(clasp-do-load :compile :propagate)

(eksl-copyright-notice "CLASP" "clasp-support@cs.umass.edu")

;;; ***************************************************************************
;;; EOF




