; remove-pop-up-item-patch.lisp
;
; Update the default-item of a pop-up menu after items are removed.

(in-package :ccl)

#-CCL-3 ; has been included in the kernel for MCL 3.0
(defmethod remove-menu-items :around ((menu pop-up-menu) &rest items)
  (declare (ignore items))
  (let* ((default-item-number (pop-up-menu-default-item menu))
         (default-item (unless (eql default-item-number 0)
                         (nth (1- default-item-number) (menu-items menu)))))
    (unwind-protect
      (call-next-method)
      (when default-item
        (let ((index (position default-item (menu-items menu))))
          (setf (pop-up-menu-default-item menu)
                (if index (1+ index) 1)))))))