;;;
;;;  top-level.lisp (extracted from about-box on 2-8-95 by Westy)
;;;

;;; 11-14-96 Added code to copy resources to the saved application.  (Westy)

(in-package :clasp-interface)

#-CCL-3
(defun clasp-toplevel ()
  (%set-toplevel 
   ;#+CCL-3
   ;#'ccl::event-processing-loop
   #-CCL-3
   #'toplevel-loop)
  (format *standard-output* "~&Welcome to CLASP~@[ ~a~]." clasp::*clasp-version*))

(defvar *clasp-development* t)

#+CCL-3
(defun save-clasp-application (&key pathname)
  (cond ((y-or-n-dialog "Save for Release or Development" 
                        :yes-text "Release" 
                        :no-text "Dev" :cancel-text "Cancel")
         (setf *clasp-development* nil)
         (setf *enable-debug-menu* nil)
         (install-clasp-menubar))
        (t
         (setf *clasp-development* t)))

  (unless pathname
    (setf pathname (choose-new-file-dialog :prompt "Save CLASP Application as..." 
                                           :directory (if *clasp-development* 
                                                        "CLASP Dev" 
                                                        (format nil "CLASP ~a" clasp::*clasp-version*)))))

  (let ((resources (make-resource-list-for-save-application)))
    (save-application pathname
                      :creator *clasp-application-creator*
                      ;:toplevel-function #'clasp-toplevel
                      :clear-clos-caches (not *clasp-development*)
                      :resources resources
                      ;:excise-compiler (not *clasp-development*)
                      )))

(eval-when (:compile-toplevel :execute :load-toplevel)
  (require :resources))

(defun load-and-detach-resource (type id-or-name)
  (let ((res (get-resource type id-or-name t t)))
    (ccl::res-error)
    (#_detachresource res)
    (#_HNoPurge res)
    res))

; The resource file contains icon ("ICN#", "icl8", etc.) resources for the
; application (id #128) and for the documents that it creates (id #129 - 133)
; and appropriate "FREF" and "BNDL" resources.
(defun make-resource-list-for-save-application (&aux resources)
  (with-open-resource-file (f "clasp:interface;clasp-resources")
    (do* ((id 128 (1+ id)))
         ((> id 133))
      (dolist (type '("FREF" "ics#" "ICN#" "icl4" "icl8" "ics4" "ics8"))
        (push (list (load-and-detach-resource type id) type id) resources)))
    ; We don't want a "CCL2" resource ...
    (push (list nil "CCL2" 0) resources)
    ; We -do- want a resource of type *clasp-application-creator* ...
    (push (list (load-and-detach-resource *clasp-application-creator* 0)
                *clasp-application-creator* 0) resources)
    ; Grab "BNDL"(128) from our resource file, replacing MCL's
    (push (list (load-and-detach-resource "BNDL" 128) "BNDL" 128) resources)
    ;; Grab the PICT resources...
    (loop for name in '("CLASP Hand" "Phoenix")
          for id from 128 do
          (push (list (load-and-detach-resource "PICT" name) "PICT" id name) resources)))
  (values resources))

;;; ---
;;; EOF
