;;;
;;; utilities-from-clim.lisp
;;;

#|
================================================================
Purpose ========================================================
================================================================
Defines some useful utilities taken from
#P"Sakura:MCL:Programs:CLASP:development:interface:utilities.lisp"


================================================================
Status =========================================================
================================================================
In-progress.


================================================================
Change history =================================================
================================================================
6-Jun-94 mc	Created.
6-Jun-94 mc	Replaced class column with variable.

|#


(in-package "CLASP")


;;;; --------------------------------------------------------------------------
;;;; translation functions
;;;; --------------------------------------------------------------------------

(defmethod simplify ((the-column variable) &rest options)
  (apply #'clasp::variable-value the-column options))

(defmethod simplify ((the-number-sequence sequence) &rest options)      ;sequence was number-sequence
  (apply #'value the-number-sequence options))

(defmethod simplify ((list cons) &key)
  (declare (ignore options))
  list)

(defmethod simplify-and-sort ((list cons))
  (declare (ignore options))
  list)

(defmethod simplify-and-sort ((variable variable))
  (variable-value variable
		  :order-by
                  #-OLD-VARS
                  variable
                  #+OLD-VARS
                  (car (clasp::variable-attribute variable))))
		  
(defmethod simplify-and-sort-by ((variable variable) (sort-variable variable))
  (variable-value variable :order-by 
                  #-OLD-VARS
                  sort-variable
                  #+OLD-VARS
                  (car (clasp::variable-attribute sort-variable))))
