;;;; -*- Mode:Common-Lisp; Package:USER; Fonts:(MEDFNT); Base:10 -*-
;;;; *-* File: Titanic: /usr/users/eksl/mac-iles/clips/defsys.lisp *-*
;;;; *-* Last-edit: Thursday, January 28, 1993  19:13:02; Edited-By: Westy *-* 
;;;; *-* Machine: Count (Explorer II, Microcode 489) *-*
;;;; *-* Software: TI Common Lisp System 6.49 *-*
;;;; *-* Lisp: TI Common Lisp System 6.49  *-*

;;;; **************************************************************************
;;;; **************************************************************************
;;;; *                                                                        *
;;;; *                       Clim 1/Clim 2 Compatability                      *
;;;; *                                                                        *
;;;; **************************************************************************
;;;; **************************************************************************
;;;
;;; Written by: David L. Westbrook
;;;             Experimental Knowledege Systems Laboratory
;;;             Paul R. Cohen, Principal Investigator
;;;             David L. Westbrook, Systems Manager
;;;             David M. Hart, Laboratory Manager
;;;             Department of Computer and Information Science
;;;             University of Massachusetts
;;;             Amherst, Massachusetts 01003.
;;;
;;; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
;;;
;;;  01-11-94 File Created.  (Carlson)
;;;
;;; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
;;; --*--

(in-package :USER)

;;; --*--
;;; ***************************************************************************

;;;; Regions

#|
(export '(clim::point-position) :clim)
(defmethod clim:point-position (point)
  (values (multiple-value-list (clim::point-postition* point))))


(export '(clim::region-contains-point-p) :clim)
(defmethod clim:region-contains-point-p (region x y)
  (clim::region-contains-point*-p region x y))
|#

;; Region-set-function replaced with standard-region-union,
;; standard-region-intersection and standard-region-difference classes.


;;;; Bounding Rectangles

#|
#-allegro
(export '(clim::bounding-rectangle-position) :clim)
#-allegro
(defmethod clim:bounding-rectangle-position (region)
  (values (multiple-value-list (clim::bounding-rectangle-postition* region))))


#-allegro
(export '(clim::bounding-rectangle-min-x clim::bounding-rectangle-max-x
	  clim::bounding-rectangle-min-y clim::bounding-rectangle-max-y) :clim)
#-allegro
(defmethod clim:bounding-rectangle-min-x (region)
  (clim:bounding-rectangle-left region))

#-allegro
(defmethod clim:bounding-rectangle-max-x (region)
  (clim:bounding-rectangle-right region))

#-allegro
(defmethod clim:bounding-rectangle-min-y (region)
  (clim:bounding-rectangle-top region))

#-allegro
(defmethod clim:bounding-rectangle-max-y (region)
  (clim:bounding-rectangle-bottom region))
|#

;;;; Affine Transformations

#|
(unless (fboundp 'clim::make-3-point-transformation-clim-1)
  (setf (symbol-function 'clim::make-3-point-transformation-clim-1) (symbol-function 'clim:make-3-point-transformation))
  (defun clim:make-3-point-transformation (point-1 point-2 point-3 point-1-image point-2-image point-3-image)
    (clim::make-3-point-transformation-clim-1 point-1 point-1-image point-2 point-2-image point-3 point-3-image)))

(unless (fboundp 'clim::make-3-point-transformation*-clim-1)
  (setf (symbol-function 'clim::make-3-point-transformation*-clim-1) (symbol-function 'clim:make-3-point-transformation*))
  (defun clim:make-3-point-transformation* (x1 y1 x2 y2 x3 y3 x1-image y1-image x2-image y2-image x3-image y3-image)
    (clim::make-3-point-transformation*-clim-1 x1 y1 x1-image y1-image x2 y2 x2-image y2-image x3 y3 x3-image y3-image)))

(export '(clim::compose-translation-with-transformation clim::compose-transformation-with-translation
	  clim::compose-scaling-with-transformation clim::compose-transformation-with-scaling
	  clim::compose-rotation-with-transformation clim::compose-transformation-with-rotation) :clim)
(defmethod clim:compose-translation-with-transformation (transform dx dy)
  (compose-translation-tranformation transform dx dy))

(defmethod clim:compose-transformation-with-translation (transform dx dy)
  (compose-translation-transformation transform dx dy))

(defmethod clim:compose-scaling-with-transformation (transform sx sy)
  (compose-translation-transformation transform sx sy))

(defmethod clim:compose-transformation-with-scaling (transform sx sy)
  (compose-translation-transformation transform sx sy))

(defmethod clim:compose-rotation-with-transformation (transform angle)
  (compose-rotation-transformation transform angle))

(defmethod clim:compose-transformation-with-rotation (transform angle)
  (compose-rotation-transformation transform angle))


(export '(clim::transform-position clim::untransform-position) :clim)
(defmethod clim:transform-position (transform x y)
  (values (multiple-value-list (clim::transform-point* transform x y))))

(defmethod clim:untransform-position (transform x y)
  (values (multiple-value-list (clim::untransform-point* transform x y))))
|#

;;;; Properties of Sheets


;;;; Sheet Protocols


;;;; Ports, Grafts and Mirrored Sheets


;;;; Text Styles


#|
(unless (fboundp 'clim::with-text-style-clim-1)
  (setf (symbol-function 'clim::with-text-style-clim-1) (symbol-function 'clim:with-text-style))
  (defmacro clim:with-text-style ((arg-1 arg-2) &body body)
    (cond
     ;; arg-1 can't be the stream
     ((or (constantp arg-1)
	  (not (symbolp arg-1)))
      `(clim::with-text-style-clim-1 (,arg-1 ,arg-2) ,@body))
     ;; arg-2 can't be the stream
     ((or (constantp arg-2)
	  (not (symbolp arg-2)))
      `(clim::with-text-style-clim-1 (,arg-2 ,arg-1) ,@body))
     (t
      ;; assume clim-1 format if unable to determine otherwise
      `(clim::with-text-style-clim-1 (,arg-1 ,arg-2) ,@body)))))

(unless (fboundp 'clim::with-text-family-clim-1)
  (setf (symbol-function 'clim::with-text-family-clim-1) (symbol-function 'clim:with-text-family))
  (defmacro clim:with-text-family ((arg-1 arg-2) &body body)
    (cond
     ;; arg-1 can't be the stream
     ((or (constantp arg-1)
	  (not (symbolp arg-1))
	  (member arg-1 '(:fix :serif :san-serif nil)))
      `(clim::with-text-style-clim-1 ((make-text-style ,arg-1 nil nil) ,arg-2) ,@body))
     ;; arg-2 can't be the stream
     ((or (constantp arg-2)
	  (not (symbolp arg-2))
	  (member arg-2 '(:fix :serif :san-serif nil)))
      `(clim::with-text-style-clim-1 ((make-text-style ,arg-2 nil nil) ,arg-1) ,@body))
     (t
      ;; assume clim-1 format if unable to determine otherwise
      `(clim::with-text-style-clim-1 ((make-text-style ,arg-1 nil nil) ,arg-2) ,@body)))))

(unless (fboundp 'clim::with-text-face-clim-1)
  (setf (symbol-function 'clim::with-text-face-clim-1) (symbol-function 'clim:with-text-face))
  (defmacro clim:with-text-face ((arg-1 arg-2) &body body)
    (cond
     ;; arg-1 can't be the stream
     ((or (constantp arg-1)
	  (not (symbolp arg-1))
	  (member arg-1 '(:roman :bold :italic nil))
	  (equal arg-1 '(:roman :bold))
	  (equal arg-1 '(:bold :roman)))
      `(clim::with-text-style-clim-1 ((make-text-style nil ,arg-1 nil) ,arg-2) ,@body))
     ((or (constantp arg-2)
	  (not (symbolp arg-2))
	  (member arg-2 '(:roman :bold :italic nil))
	  (equal arg-2 '(:roman :bold))
	  (equal arg-2 '(:bold :roman)))
      `(clim::with-text-style-clim-1 ((make-text-style nil ,arg-2 nil) ,arg-1) ,@body))
     (t
      ;; assume clim-1 format if unable to determine otherwise
      `(clim::with-text-style-clim-1 ((make-text-style nil ,arg-1 nil) ,arg-2) ,@body)))))

(unless (fboundp 'clim::with-text-size-clim-1)
  (setf (symbol-function 'clim::with-text-size-clim-1) (symbol-function 'clim:with-text-size))
  (defmacro clim:with-text-size ((arg-1 arg-2) &body body)
    (cond
     ;; arg-1 can't be the stream
     ((or (constantp arg-1)
	  (numberp arg-1)
	  (not (symbolp arg-1))
	  (member arg-1 '(:normal :tiny :very-small :small :large :very-large :huge :smaller :larger nil)))
      `(clim::with-text-style-clim-1 ((make-text-style nil nil ,arg-1) ,arg-2) ,@body))
     ;; arg-2 can't be the stream
     ((or (constantp arg-2)
	  (numberp arg-2)
	  (not (symbolp arg-2))
	  (member arg-2 '(:normal :tiny :very-small :small :large :very-large :huge :smaller :larger nil)))
      `(clim::with-text-style-clim-1 ((make-text-style nil nil ,arg-2) ,arg-1) ,@body))
     (t
      ;; assume clim-1 format if unable to determine otherwise
      `(clim::with-text-style-clim-1 ((make-text-style nil nil ,arg-1) ,arg-2) ,@body)))))
|#

;; add-text-style-mapping -> (setf text-style-mapping) - no documentation in clim 1


;;;; Drawing in Color

(export '(clim::+foreground-ink+ clim::+background-ink+) :clim)
(defconstant clim::+foreground-ink+ clim:+foreground+)
(defconstant clim::+background-ink+ clim:+background+)


#|
(export '(clim::make-rgb-color clim::make-ihs-color) :clim)
(defmethod clim:make-rgb-color (red green blue)
  (clim::make-color-rgb red green blue))

(defmethod clim:make-ihs-color (intensity hue saturation)
  (clim::make-color-ihs intensity hue saturation))
|#

;;;; Extended Stream Output

#|
(export '(clim::stream-cursor-position clim::stream-increment-cursor-position) :clim)
(defmethod clim:stream-cursor-position (stream)
  (values (multiple-value-list (clim::stream-cursor-postition* stream))))

(defmethod clim:stream-increment-cursor-position (stream dx dy)
  (clim::stream-increment-cursor-postition* stream dx dy))
|#

;; this probably won't work, since the improved defgeneric* and
;; defmethod* isn't in clim-1, unless this does work by some miraculous
;; twist of fate, I'm not adding any of the other setf* methods.
#+ignore
(clim:defmethod* (setf clim:stream-cursor-position) (nx ny stream)
  (clim:stream-set-cursor-position* stream nx ny))


#|
(export '(clim::stream-vertical-spacing) :clim)
(defmethod stream-vertical-spacing (stream)
  (clim::stream-vsp stream))


(unless (fboundp 'clim::with-end-of-line-action-clim-1)
  (setf (symbol-function 'clim::with-end-of-line-action-clim-1) (symbol-function 'clim:with-end-of-line-action))
  (defmacro clim:with-end-of-line-action ((stream action) &body body)
    `(clim::with-end-of-line-action-clim-1 (,action ,stream) ,@body)))

(unless (fboundp 'clim::with-end-of-page-action-clim-1)
  (setf (symbol-function 'clim::with-end-of-page-action-clim-1) (symbol-function 'clim:with-end-of-page-action))
  (defmacro clim:with-end-of-page-action ((stream action) &body body)
    `(clim::with-end-of-page-action-clim-1 (,action ,stream) ,@body)))
|#

;;;; Output Recording

;; output-record, output-record-element,
;; displayed-output-record-element replaced by output-record and
;; diplayed-output-record - how to change classes and reuse name?


#|
(export '(clim::output-record-position) :clim)
(defmethod clim:output-record-position (record)
  (values (multiple-value-list (clim::output-record-position*-clim-1 record))))


(export '(clim::output-record-start-position clim::output-record-end-position) :clim)
(defmethod clim:output-record-start-position (record)
  (values (multiple-value-list (clim:output-record-start-position* record))))

(defmethod clim:output-record-end-position (record)
  (values (multiple-value-list (clim:output-record-end-position* record))))


(export '(clim::replay-output-record) :clim)
(defmethod clim:replay-output-record (record stream &optional region (x-offset (coordinate 0)) (y-offset (coordinate 0)))
  (clim:replay-1 record stream region x-offset y-offset))


(export '(clim::output-record-children clim::output-record-count) :clim)
(defmethod clim:output-record-children (record)
  (clim::output-record-elements record))

(defmethod clim:output-record-count (record &key fastp)
  (clim::output-record-element-count record :fastp fastp))


(export '(clim::add-output-record clim::add-output-record-clim-1) :clim)
(setf (symbol-function 'clim:add-output-record-clim-1) (symbol-function 'clim:add-output-record))
(defmethod clim:add-output-record (child (record output-record-mixin))
  (clim:add-output-record-element record child))


(export '(clim::delete-output-record) :clim)
(defmethod clim:delete-output-record (child record &optional (errorp t))
  (clim:delete-output-record-element record child errorp))


(export '(clim::map-over-output-records-containing-position clim::map-over-output-records-overlapping-region) :clim)
(defmethod clim:map-over-output-records-containing-position (function record x y &optional x-offset y-offset
							     &rest continuation-args)
  (apply #'clim:map-over-output-record-elements-containing-point* record x y function x-offset y-offset continuation-args))

(defmethod clim:map-over-output-records-overlapping-region (function record region &optional x-offset y-offset
							    &rest continuation-args)
  (apply #'clim:map-over-output-record-elements-overlapping-region record region function x-offset y-offset
	 continuation-args))

(export '(clim::standard-sequence-output-record clim::standard-tree-output-record) :clim)
(defclass clim:standard-sequence-output-record (clim::linear-output-record) ())

(defclass clim:standard-tree-output-record (clim::coordinate-sorted-set-output-record) ())


(export '(clim::stream-drawing-p clim::stream-recording-p) :clim)
(defmethod clim:stream-drawing-p (stream)
  (clim:stream-draw-p stream))

(defmethod (setf clim:stream-drawing-p) (stream new-value)
  (setf (clim:stream-draw-p stream) new-value))

(defmethod clim:stream-recording-p (stream)
  (clim:stream-record-p stream))

(defmethod (setf clim:stream-recording-p) (stream new-value)
  (setf (clim:stream-record-p stream) new-value))


(export '(clim::stream-output-history clim::stream-current-output-record clim::stream-text-output-record) :clim)
(defmethod clim:stream-output-history (stream)
  (clim:output-recording-stream-output-record stream))

(defmethod clim:stream-current-output-record (stream)
  (clim::output-recording-stream-current-output-record-stack stream))

(defmethod clim:stream-text-output-record (stream)
  (clim::output-recording-stream-text-output-record stream))


(export '(clim::stream-add-output-record) :clim)
(defmethod clim:stream-add-output-record (stream record)
  (clim:add-output-record-clim-1 stream record))


(export '(clim::stream-close-text-output-record) :clim)
(defmethod clim:stream-close-text-output-record (stream &optional wrapped)
  (clim::close-current-text-output-record stream wrapped))


(export '(clim::stream-add-string-output clim::stream-add-character-output) :clim)
(defmethod clim:stream-add-string-output (stream string start end text-style width height baseline)
  (clim::add-string-output-to-output-record stream string start end text-style width height baseline))

(defmethod clim:stream-add-character-output (stream character text-style width height baseline)
  (clim::add-character-output-to-output-record stream character text-style width height baseline))


(unless (fboundp 'clim::with-output-recording-options-clim-1)
  (setf (symbol-function 'clim::with-output-recording-options-clim-1)
    (symbol-function 'clim:with-output-recording-options))
  (defmacro clim:with-output-recording-options ((stream &key draw record draw-p record-p) &body body)
    `(clim::with-output-recording-options-clim-1 (,stream :draw-p ,(or draw draw-p)
							  :record-p ,(or record record-p)) ,@body)))
|#

;;;; Table Formatting

#|
(unless (fboundp 'clim::formatting-table-clim-1)
  (setf (symbol-function 'clim::formatting-table-clim-1) (symbol-function 'clim:formatting-table))
  (defmacro clim:formatting-table ((&optional stream
				    &rest options
				    &key x-spacing y-spacing
					 inter-row-spacing inter-column-spacing
					 multiple-columns multiple-columns-x-spacing
					 equalize-column-widths record-type (move-cursor t) &allow-other-keys)
				   &body body)
    `(clim::formatting-table-clim-1 (,stream :inter-row-spacing ,(or x-spacing inter-row-spacing)
					     :inter-column-spacing ,(or y-spacing inter-column-spacing)
					     :multiple-columns ,multiple-columns :record-type ,record-type
					     :multiple-columns-inter-column-spacing ,multiple-columns-x-spacing
					     :equalize-column-widths ,equalize-column-widths :move-cursor ,move-cursor)
				    ,@body)))

(unless (fboundp 'clim::formatting-cell-clim-1)
  (setf (symbol-function 'clim::formatting-cell-clim-1) (symbol-function 'clim:formatting-cell))
  (defmacro clim:formatting-cell ((&optional stream &rest options
				   &key  min-width min-height
					 minimum-width minimum-height
					 (align-x :left) (align-y :top) record-type
				   &allow-other-keys) &body body)
    `(clim::formatting-cell-clim-1 (,stream :align-x ,align-x :align-y ,align-y :record-type ,record-type
					    :minimum-width ,(or min-width minimum-width)
					    :minimum-height ,(or min-height minimum-height))
				   ,@body)))

(unless (fboundp 'clim::formatting-item-list-clim-1)
  (setf (symbol-function 'clim::formatting-item-list-clim-1) (symbol-function 'clim:formatting-item-list))
  (defmacro clim:formatting-item-list ((&optional stream &rest options
					&key x-spacing y-spacing
					     inter-row-spacing inter-column-spacing
					     record-type initial-spacing n-columns n-rows
					     max-width max-height stream-width stream-height row-wise (move-cursor t)
					&allow-other-keys) &body body)
    `(clim::formatting-item-list-clim-1 (,stream :record-type ,record-type :no-initial-spacing ,(not initial-spacing)
						 :inter-row-spacing ,(or x-spacing inter-row-spacing)
						 :inter-column-spacing ,(or y-spacing inter-column-spacing)
						 :n-columns ,n-columns :n-rows ,n-rows
						 :max-width ,max-width :max-height ,max-height
						 :stream-width ,stream-width :stream-height ,stream-height
						 :move-cursor ,move-cursor)
					,@body)))
|#

;; All the formatting macros will expand to calls to format-items, so
;; I don't want to redefine it.  Instead I create a format-items-clim-2
;; which converts its arguments to clim-1 arguments and calls the clim-1
;; version.  This does mean the lisp file will need to have explicit
;; calls to format-items conditionalized.

#|
(unless (fboundp 'clim::format-items-clim-1)
  (setf (symbol-function 'clim::format-items-clim-1) (symbol-function 'clim:format-items))
  (defun clim:format-items (items
			    &key x-spacing y-spacing inter-row-spacing inter-column-spacing
				 (stream *standard-output*) printer presentation-type
				 initial-spacing row-wise n-rows n-columns max-width max-height record-type
				 (cell-align-x :left) (cell-align-y :top))
    (clim::format-items-clim-1 items :stream stream :printer printer :presentation-type presentation-type
			       :inter-column-spacing (or x-spacing inter-row-spacing)
			       :inter-row-spacing (or y-spacing inter-column-spacing)
			       :no-initial-spacing (not initial-spacing) :n-rows n-rows :n-columns n-columns
			       :max-width max-width :max-height max-height :record-type record-type
			       :cell-align-x cell-align-x :cell-align-y cell-align-y)))
|#

;;;; Graph Formatting

(export '(clim::format-graph-from-roots) :clim)
(defun clim:format-graph-from-roots (root-objects object-printer inferior-producer
				     &key (stream *standard-output*) (orientation :horizontal)
					  cutoff-depth (generation-separation clim:*default-generation-separation*)
					  (within-generation-separation clim:*default-generation-separation*)
					  merge-duplicates graph-type duplicate-key duplicate-test center-nodes
					  arc-drawer arc-drawing-options maximize-generations
					  offpage-connector-out-printer offpage-connector-in-printer store-objects
					  (move-cursor t))
  (clim:format-graph-from-root (first root-objects) object-printer inferior-producer
			       :stream stream :orientation orientation 
			       :cutoff-depth cutoff-depth :generation-separation generation-separation
			       :within-generation-separation within-generation-separation :move-cursor move-cursor
					; None of the following arguments are standard clim-1
			       :merge-duplicates merge-duplicates :graph-type graph-type :duplicate-key duplicate-key
			       :duplicate-test duplicate-test :center-nodes center-nodes :arc-drawer arc-drawer
			       :arc-drawing-options arc-drawing-options :maximize-generations maximize-generations
			       :offpage-connector-out-printer offpage-connector-out-printer
			       :offpage-connector-in-printer offpage-connector-in-printer :store-objects store-objects))


;;;; Incremental Redipsplay

#|
(export '(clim::redisplay-output-record) :clim)
(defmethod clim:redisplay-output-record (record stream &optional check-overlapping x y parent-x parent-y)
  (clim:redisplay-1 record stream check-overlapping x y parent-x parent-y))
|#

;;;; Extended Stream Input

(export '(clim::stream-pointer-position) :clim)
(defmethod clim::stream-pointer-position (stream &key timeout pointer)
  (declare (ignore timeout))
  (clim:stream-pointer-position* stream :pointer pointer))


;; tracking-pointer macro has changed

#|
(export '(clim::drag-output-record) :clim)
(defmethod clim:drag-output-record (stream output-record
				    &key (repaint t) (erase #'clim:erase-output-record) feedback finish-on-release
					 multiple-window)
  (clim:dragging-output-record stream output-record :repaint repaint :erase erase :feedback feedback
			       :finish-on-release finish-on-release
					; The following is not a standard clim-1 argument
			       :multiple-window multiple-window))

(unless (fboundp 'clim::dragging-output-clim-1)
  (setf (symbol-function 'clim::dragging-output-clim-1) (symbol-function 'clim:dragging-output))
  (defmacro clim:dragging-output ((stream &key repaint multiple-window finish-on-release) &body body)
    `(clim::dragging-output-clim-1 (,stream ,repaint ,finish-on-release)
				   ,@body)))
|#

;;;; Presentation Types

#|
(unless (fboundp 'clim::with-output-as-presentation-clim-1)
  (setf (symbol-function 'clim::with-output-as-presentation-clim-1) (symbol-function 'clim:with-output-as-presentation))
  (defmacro clim:with-output-as-presentation ((&rest args)
					      &body body)
    (let (stream object type modifier single-box allow-sensitive-inferiors parent record-type)
      ;; if there is no :stream, :object or :type arg, and the first
      ;; through third members of args are not keywords, then assume
      ;; it's in clim-2 format and translate otherwise just pass it on
      (if (and (not (member :stream args))
	       (not (member :object args))
	       (not (member :type args))
	       (not (and (symbolp (first args)) (eq (symbol-package (first args)) (find-package :keyword))))
	       (not (and (symbolp (second args)) (eq (symbol-package (second args)) (find-package :keyword))))
	       (not (and (symbolp (third args)) (eq (symbol-package (third args)) (find-package :keyword)))))
	  (setf stream (first args)
		object (second args)
		type (third args)
		args (nthcdr 3 args))
	(progn
	  (setf stream (getf args :stream))
	  (setf object (getf args :object))
	  (setf type (getf args :type))
	  (setf args (remf args :stream))
	  (setf args (remf args :object))
	  (setf args (remf args :type))))
      (setf modifier (getf args :modifier))
      (setf args (remf args :modifier))
      (setf single-box (getf args :single-box))
      (setf args (remf args :single-box))
      (if (member :allow-sensitive-inferiors args)
	  (setf allow-sensitive-inferiors (getf args :allow-sensitive-inferiors)
		args (remf args :allow-sensitive-inferiors))
	(setf allow-sensitive-inferiors t))
      (setf parent (getf args :parent))
      (setf args (remf args :parent))
      (setf record-type (getf args :record-type))
      (setf args (remf args :record-type))
      `(clim::with-output-as-presentation-clim-1 (:stream ,(first args) :object ,(second args) :type ,(third args)
							  :modifier ,modifier :single-box ,single-box
							  :allow-sensitive-inferiors ,allow-sensitive-inferiors
							  :parent ,parent :record-type ,record-type ,@args)
	 ,@body))))
|#

(export '(clim::textual-dialog-view clim::+textual-dialog-view+ clim::textual-menu-view clim::+textual-menu-view+) :clim)
(defclass clim::textual-dialog-view (dialog-view) ())

(defconstant clim::+textual-dialog-view+ clim:+dialog-view+)

(defclass clim::textual-menu-view (menu-view) ())

(defconstant clim::+textual-menu-view+ clim:+menu-view+)


;;;; Input Editing and Completion Facilities

#|
(export '(clim::with-activation-gestures) :clim)
(defmacro clim:with-activation-gestures ((&rest args) &body body)
  `(clim:with-activation-characters ,args ,@body))


(export '(clim::with-delimiter-gestures) :clim)
(defmacro clim:with-delimiter-gestures ((&rest args) &body body)
  `(clim:with-blip-characters ,args ,@body))
|#

;;;; Menus

#|
(unless (fboundp 'clim::menu-choose-clim-1)
  (setf (symbol-function 'clim::menu-choose-clim-1) (symbol-function 'clim:menu-choose))
  (defmethod clim:menu-choose (items &rest keys 
			       &key associated-window text-style default-item label scroll-bars printer presentation-type
				    cache unique-id id-test cache-value cache-test max-width max-height n-rows n-columns
				    x-spacing y-spacing inter-column-spacing inter-row-spacing 
				    cell-align-x cell-align-y pointer-documentation menu-type)
    (clim::menu-choose-clim-1 items :associated-window associated-window :text-style text-style :default-item default-item
			      :label label :scroll-bars scroll-bars :printer printer :presentation-type presentation-type
			      :cache cache :unique-id unique-id :id-test id-test :cache-value cache-value
			      :cache-test cache-test :max-width max-width :max-height max-height
			      :n-rows n-rows :n-columns n-columns :cell-align-x cell-align-x :cell-align-y cell-align-y
			      :inter-column-spacing (or x-spacing inter-column-spacing)
			      :inter-row-spacing (or y-spacing inter-row-spacing) :menu-type menu-type
			      :pointer-documentation pointer-documentation)))
|#

;;;; Command Processing

#|
(unless (fboundp 'clim::display-command-table-menu-clim-1)
  (setf (symbol-function 'clim::display-command-table-menu-clim-1) (symbol-function 'clim:display-command-table-menu))
  (defun clim:display-command-table-menu (command-table stream
					  &key max-width max-height n-rows n-columns x-spacing y-spacing
					       cell-align-x cell-align-y initial-spacing (no-initial-spacing t)
					       row-wise move-cursor)
    (declare (ignore row-wise))
    (clim::display-command-table-menu-clim-1 command-table stream
					     :max-width max-width :max-height max-height
					     :n-rows n-rows :n-columns n-columns
					     :inter-column-spacing x-spacing :inter-row-spacing y-spacing
					     :cell-align-x cell-align-x :cell-align-y cell-align-y
					     :no-initial-spacing (and (not initial-spacing) no-initial-spacing)
					     :move-cursor move-cursor)))
|#


;;;; Application Frames

#|
(defmethod (setf clim:frame-current-layout) (layout frame)
  (clim:set-frame-layout frame layout))


(export '(clim::frame-top-level-sheet) :clim)
(defmethod clim:frame-top-level-sheet (frame)
  (clim:frame-top-level-window frame))

(export '(clim::command-enabled) :clim)
(defmethod clim:command-enabled (command-name frame)
  (clim:command-enabled-p command-name frame))

(defmethod (setf clim:command-enabled) (new-value command-name frame)
  (if new-value
      (clim:enable-command command-name frame)
    (clim:disable-command command-name frame)))


(export '(clim::window-viewport-position) :clim)
(defmethod clim:window-viewport-position (window)
  (values (multiple-value-list (clim:window-viewport-position* window))))
|#

;;;; Panes

;; You're on your own
