;;;; -*- Mode:Common-Lisp; Package:USER; Fonts:(MEDFNT); Base:10 -*-
;;;; *-* File: Titanic: /usr/users/eksl/mac-iles/clips/defsys.lisp *-*
;;;; *-* Last-edit: Thursday, January 28, 1993  19:13:02; Edited-By: Westy *-* 
;;;; *-* Machine: Count (Explorer II, Microcode 489) *-*
;;;; *-* Software: TI Common Lisp System 6.49 *-*
;;;; *-* Lisp: TI Common Lisp System 6.49  *-*

;;;; **************************************************************************
;;;; **************************************************************************
;;;; *                                                                        *
;;;; *                       Clim 1/Clim 2 Compatability                      *
;;;; *                                                                        *
;;;; **************************************************************************
;;;; **************************************************************************
;;;
;;; Written by: David L. Westbrook
;;;             Experimental Knowledege Systems Laboratory
;;;             Paul R. Cohen, Principal Investigator
;;;             David L. Westbrook, Systems Manager
;;;             David M. Hart, Laboratory Manager
;;;             Department of Computer and Information Science
;;;             University of Massachusetts
;;;             Amherst, Massachusetts 01003.
;;;
;;; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
;;;
;;;  01-11-94 File Created.  (Carlson)
;;;
;;; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
;;; --*--

(in-package :USER)

;;; --*--
;;; ***************************************************************************

;;; This file is a hack to get clasp working under clim 2.0 relatively
;;; quickly.  Eventually, the code itself should be conditionalized to use
;;; the correct versions of the constants which are renamed in CLIM 2.0
;;; (even though CLIM 2.0 is supposed to recognize the old symbols for
;;; backwards compatability.)  I have attempted to follow the  Clim 2.0
;;; Spec., Appendix E. Changes from Clim 1.0, sections.

#+ignore
(common-lisp:eval-when (common-lisp:load common-lisp:compile common-lisp:eval)		       
  (common-lisp:let ((compiler:*cltl1-compile-file-toplevel-compatibility-p* t)
		    (excl:*enable-package-locked-errors* nil))
    (common-lisp:shadowing-import
     '(clim:truename clim:interactive-stream-p clim:pathname) :common-lisp)
    (common-lisp:use-package :common-lisp)))

;;; Regions

;;; Bounding Rectangles

;;; Text Styles
(defconstant clim::with-text-style-2.0 (symbol-function 'clim:with-text-style))
(defmacro clim:with-text-style ((text-options &optional stream) &body body)
  `(clim::with-text-style-2.0 (,stream ,text-options)
     ,@body))

(defconstant clim::with-text-family-2.0 (symbol-function 'clim:with-text-family))
(defmacro with-text-family ((text-options &optional stream) &body body)
  `(clim::with-text-family-2.0 (,stream ,text-options)
     ,@body))

(defconstant clim::with-text-face-2.0 (symbol-function 'clim:with-text-face))
(defmacro clim:with-text-face ((text-options &optional stream) &body body)
  `(clim::with-text-face-2.0 (,stream ,text-options)
     ,@body))

(defconstant clim::with-text-size-2.0 (symbol-function 'clim:with-text-size))
(defmacro clim:with-text-size ((text-options &optional stream) &body body)
  `(clim::with-text-size-2.0 (,stream ,text-options)
     ,@body))

;;; Drawing in Color
(defconstant clim::+foreground+ clim:+foreground-ink+)
(defconstant clim::+background+ clim:+background-ink+)

;;; Extended Stream Output
(defun clim::stream-cursor-position* (stream)
  (funcall #'clim:stream-cursor-position stream))

(defun clim::stream-increment-cursor-position* (stream dx dy)
  (funcall #'clim:stream-increment-cursor-position stream dx dy))

;;; Extended Stream Input
(defun clim::stream-pointer-position* (stream &key pointer)
  (clim:stream-pointer-position stream :pointer pointer))

(defun clim::stream-set-pointer-position* (stream x y &key pointer)
  (clim-utils::setf* (clim:stream-pointer-position stream :pointer pointer) x y))

(defun clim::event-window (event)
  (clim:event-sheet event))

(defconstant clim::dragging-output-2.0 (symbol-function 'clim:dragging-output))
(defmacro clim:dragging-output ((&optional stream repaint finish-on-release) &body body)
  `(clim::dragging-output-2.0 (,stream :repaint ,repaint :finish-on-release ,finish-on-release)
			      ,@body))

;;; Presentation Types
(defconstant clim::with-output-as-presentation-2.0 (symbol-function 'clim:with-output-as-presentation))
(defmacro clim:with-output-as-presentation ((&rest args
					     &key object type stream modifier single-box
						  (allow-sensitive-inferiors t) record-type) &body body)
  `(clim::with-output-as-presentation-2.0 (,stream ,object ,type
					   :modifier ,modifier :single-box ,single-box
					   :allow-sensitive-inferiors ,allow-sensitive-inferiors
					   :record-type ,record-type)
     ,@body))

(defclass clim::dialog-view (clim:textual-dialog-view) ())
(defconstant clim::+dialog-view+ clim:+textual-dialog-view+)
(defclass clim::menu-view (clim:textual-menu-view) ())
(defconstant clim::+menu-view+ clim:+textual-menu-view+)

;;; Others

;;; Designs
(defun clim::draw-icon* (stream pattern x y &rest args &key clipping-region transformation)
  (declare (ignore clipping-region transformation))
  (apply #'clim:draw-pattern* stream pattern x y args))

;;; Exporting

(defconstant *clim-patches-export-list*
    '(;; clim:with-text-style clim:with-text-family clim:with-text-face clim:with-text-size
      clim::+foreground+ clim::+background+
      clim::stream-cursor-position* clim::stream-increment-cursor-position*
      clim::dialog-view clim::+dialog-view+ clim::menu-view clim::+menu-view+
      clim::stream-pointer-position* clim::stream-set-pointer-position* clim::event-window
      clim::draw-icon*))

(export *clim-patches-export-list* (find-package :clim))
