;;;; -*- Mode:Common-Lisp; Package:CLASP-INTERFACE; Base:10 -*-
;;;; *-* File: Titanic: /usr/users/eksl/group-files/clasp/v3dev/interface/data-manipulation-commands.lisp *-*
;;;; *-* Last-edit: Thursday, February 18, 1993  00:54:05; Edited-By: carlson *-* 
;;;; *-* Machine: Miles (Explorer II, Microcode 489) *-*
;;;; *-* Software: TI Common Lisp System 6.49 *-*
;;;; *-* Lisp: TI Common Lisp System 6.49  *-*

;;;; **************************************************************************
;;;; **************************************************************************
;;;; *                                                                        *
;;;; *                       Data Manipulation Commands                       *
;;;; *                                                                        *
;;;; **************************************************************************
;;;; **************************************************************************
;;;
;;; Written by: Adam Carlson
;;;             Experimental Knowledge Systems Laboratory
;;;             Paul R. Cohen, Principal Investigator
;;;             David L. Westbrook, Systems Manager
;;;             David M. Hart, Laboratory Manager
;;;             Department of Computer Science
;;;             University of Massachusetts
;;;             Amherst, Massachusetts 01003.
;;;
;;; Copyright (c) 1990 1991 1992 University of Massachusetts
;;; Department of Computer Science
;;; Created by the Experimental Knowledge Systems Laboratory
;;;    under the direction of Professor Paul R. Cohen.
;;; For more information write to Dhart@cs.umass.edu (Internet)
;;;
;;; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
;;;
;;;  02-18-93 File Created.  (carlson)
;;;
;;; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
;;; --*--

(in-package #+CLTL2 CLASP-INTERFACE #-CLTL2 'CLASP-INTERFACE)

;;; --*--
;;; ***************************************************************************


(define-command-table clasp-data-manipulation)

(add-menu-item-to-command-table 'clasp "Manipulate" 
                                :menu 'clasp-data-manipulation 
                                :errorp nil :after "Describe")



(defstat rename-dataset data-manipulation 
  (dataset string) (t t) 
  () ())

(defstat rename-variable data-manipulation
  (column string) (t t) 
  () ())

(defstat add-variable-to-dataset data-manipulation
  (dataset expression string) (t t t)
  (t) (expression))

(defstat create-new-column-from-function data-manipulation
  (dataset expression) (t t )
  (t) (column))

(defstat make-dataset-from-partition data-manipulation
  (dataset expression) (t t) 
  (t) ((or dataset (sequence dataset))))

(defstat delete-dataset data-manipulation
  (dataset) (t) 
  () ())

(defstat delete-variable data-manipulation
  (variable) (t) 
  () ())

;;; ***************************************************************************
;;; EOF
