;;;-*- Mode: Lisp; Package: CLASP-INTERFACE -*-

(in-package :clasp-interface)


(define-command-table tests)

(add-menu-item-to-command-table 'clasp "Debug" :menu 'tests :errorp nil)

(defun print-args (&rest args)
  (print args *standard-output*))

#+old
(define-command (com-create-drag-button :command-table tests :menu t :name "Create Drag Button")
    ((icon 'dragged-icon)
     (point 'window-point))
  (place-in-window icon
		   (window point)
		   (point-x point) (point-y point)))

#+old
(define-command (com-create-graph :command-table tests :menu t :name "Place Graph")
                ()
  (place (make-graph-icon 
          :graph
          (graph-user::make-sample-graph 
           :dataset-function (nth (random (length graph-user::*all-sample-data-functions*))
                                  graph-user::*all-sample-data-functions*)))))

#+old
(define-command (com-colored-point-graph :command-table tests :menu t :name "Place Colored Point Graph")
    ()
  (let* ((graph-icon (make-graph-icon))
         (graph (graph graph-icon))) 
    (graph::add-dataset graph (graph-user::make-sample-data-scatter))
    (graph::add-dataset graph (graph-user::make-sample-data-scatter-red))
    (place graph-icon)))

#+old
(define-command (com-make-sample-data-scatter :command-table tests :menu t :name "Make Scatter Data")
    ()
  (let ((icon (make-instance 'graph-data-icon
                :graph-data (graph-user::make-sample-data-scatter))))
    (place icon)))

#+old
(define-command (com-make-sample-data-scatter-2 :command-table tests :menu t :name "Make Scatter Data 2")
    ()
  (let ((icon (make-instance 'graph-data-icon
                :graph-data (graph-user::make-sample-data-scatter-red))))
    (place icon)))

(defun build-test-datasets ()
  (loop repeat 3 do
        (let ((dataset (make-instance clasp::*dataset-class*)))
          (setf (slot-value dataset 'clasp::variables)
                (loop repeat 5
                      collect (make-instance clasp::*variable-class*
                                :dataset dataset
                                :value (graph-user::pseudo-random-data
		                        3 13 1
		                        #'sin .2)))))))

(define-command (com-build-test-datasets :command-table tests :menu "Build Datasets") ()
  (build-test-datasets))

(defun build-anova-tester-dataset ()
  (let ((dataset (make-instance clasp::*dataset-class* :name "Anova Tester")))
    (setf (slot-value dataset 'clasp::variables)
          (list
           (make-instance clasp::*variable-class* :dataset dataset :value '(1 1 1 2 2 2))
           (make-instance clasp::*variable-class* :dataset dataset :value '(1 2 3 11 12 13))))))

(define-command (com-build-anova-tester-datasets :command-table tests :menu "Build Anova Tester Dataset") ()
  (build-anova-tester-dataset))

#+OLD
(define-command (com-create-window :command-table tests :menu "Create Inferior Window") ()
  (make-inferior-window *application-frame*))

