;;; -*- Mode: LISP; Syntax: Common-Lisp; Base: 10; Package:CLASP-INTERFACE -*-

(in-package :CLASP-INTERFACE)

;; ----------------------------------------------------------------------------
;;; The FILE menu
;; (more to come!)

(define-command-table clasp-file)

(add-menu-item-to-command-table 'clasp "File" :menu 'clasp-file :errorp nil :after :start)

(define-command (COM-HELP-ME :command-table clasp-file :name t :menu  "Help Menu") ()
  ) 

(define-command (COM-LOAD-DATASET :command-table clasp-file :name t :menu  "Load Dataset") 
                ((pathname 'pathname))
  (load-dataset pathname))

(define-command (COM-SAVE-DATASET :command-table clasp-file :name t :menu  "Save Dataset") 
                ((dataset 'dataset)
                 (pathname 'pathname))
  (save-dataset dataset pathname))

(define-command (COM-WRITE-ASCII-FILE-OR-BUFFER :command-table clasp-file :name t :menu  "Save Dataset As...") ()
  (write-ascii-file-or-buffer))

(define-command (com-kill-everything :command-table clasp-file  :menu "Delete All Datasets") ()
  (clasp::forget-instances 'dataset)
  ;; Handle the clasp variables as well.
  (setf clasp::*clasp-active-datasets* nil)
  (setf clasp::*clasp-datasets* nil))

(define-command (com-clear :command-table clasp-file :menu "Clear Desktop") ()
  (window-clear *clasp-frame-main-window*))

(define-command (COM-SET-GLOBAL-VARIABLE-VALUES :command-table clasp-file :name t :menu  "Preferences") ()
  (set-global-variable-values (frame-query-io *application-frame*)))

(define-command (com-quit-clasp :command-table clasp-file :name t :menu "Quit")
   ()
  (frame-exit *application-frame*))

;;; ----------------------------------------------------------------------------

#| 
(define-command-table clasp-show)

(add-menu-item-to-command-table 'clasp "Show" :menu 'clasp-show :errorp nil :after "Plotting")

(define-command (COM-PRINT-ALL-DATA :command-table clasp-show :name t :menu  "Show All Data") ()
  (print-all-data))

(define-command (com-print-data-multiple-columns :command-table clasp-show :name t :menu  "Show Data Multiple Columns") ()
  "Displays the values for the selected variable."
  (let ((data-set (current-data-set *application-frame*)))
		(dolist (var (get-variable :data-set data-set :get-multiple t :label "Select variables to view."))
		  (print-column-data (column-number var) :data-set data-set))))

(define-command (com-print-data-row :command-table clasp-show :name t :menu  "Show All Data by Row") ()
  "Display all values for a selected Dataset one row at a time."
  (if (#+MCL ccl::y-or-n-dialog #-MCL y-or-n-p "Show just the current dataset?")
    (let ((d-set (current-data-set *application-frame*)))
      (dotimes (i (array-dimension (data-set-data-array d-set) 0))
        (unless (print-row-data i :data-set d-set) (return))))
    (catch 'up 
      (dolist (set *data-set-list*)
        (let ((d-set (eval set)))
          (dotimes (i (array-dimension (data-set-data-array d-set) 0))
            (unless (print-row-data i :data-set d-set) 
              (throw 'up nil))))))))

(define-command (com-print-variable-column-and-data-set :command-table clasp-show :name t :menu  "Show Variable Stuff") ()
  "Display the column number and data-set title of a variable."
  (multiple-value-bind (num set)
    (column-number (caar (get-multi-set-data)))
		(format *clasp-report-stream* "~%Column number: ~d, dataset: ~a~%"
			num set)))

(define-command (print-variable-symbols-and-names :command-table clasp-show :name t :menu  "Show Variable Symbols and Names") ()
  "Display all internal symbols and variable name strings for a selected dataset, or all datasets."
  (if (#+MCL ccl::y-or-n-dialog #-MCL y-or-n-p "Show just the current dataset?")
		  (print-variable-symbol-name 
		    :data-set (current-data-set *application-frame*))
		  (print-variable-symbol-name)))

|#
;;; ----------------------------------------------------------------------------
