;;; -*- Syntax: Common-Lisp; Package: CLASP-INTERFACE; Base: 10; Mode: LISP; -*-

;;; Copyright (c) 1990 - 1994 University of Massachusetts
;;; Department of Computer Science
;;; Experimental Knowledge Systems Laboratory
;;; Professor Paul Cohen, Director.
;;; All rights reserved.

;;; Permission to use, copy, modify and distribute this software and its
;;; documentation is hereby granted without fee, provided that the above
;;; copyright notice of EKSL, this paragraph and the one following appear
;;; in all copies and in supporting documentation.
;;; EKSL makes no representation about the suitability of this software for any
;;; purposes.  It is provided "AS IS", without express or implied warranties
;;; including (but not limited to) all implied warranties of merchantability
;;; and fitness for a particular purpose, and notwithstanding any other
;;; provision contained herein.  In no event shall EKSL be liable for any
;;; special, indirect or consequential damages whatsoever resulting from loss
;;; of use, data or profits, whether in an action of contract, negligence or
;;; other tortuous action, arising out of or in connection with the use or
;;; performance of this software, even if EKSL is advised of the possiblity of
;;; such damages.

;;; For more information write to clasp-support@cs.umass.edu

(in-package :clasp-interface)

(defmethod update-history ((frame clasp-frame) command-or-form values)
  (push (list command-or-form values) (slot-value frame 'history)))

(defmethod dump-history ((frame clasp-frame) &key (stream *standard-output*))
  (let ((*print-escape* nil)
        (*package* (find-package 'clasp-interface))
	(clasp::*override-print-escape* t))
    (with-output-to-postscript-stream (postscript-stream stream :multi-page t)
       ;; I assume a better way to do this would be to replay the output history.
       (dolist (item (reverse (slot-value frame 'history)))
         (print (first item) postscript-stream)
         (terpri postscript-stream)
         (when (second item)
           (typecase (second item)
             (result (display (second item) postscript-stream))
             (t (print (second item) postscript-stream))))
	 (terpri postscript-stream)))))

  
;; For debugging
(defun clasp-user::dh (&optional (stream *standard-output*))
  (dump-history (clasp-frame) :stream stream))

  
    
