;;;; -*- Mode:Common-Lisp; Package:eksl-utilities; Fonts:(medfnt courierfb hl12i tr12 medfnb cptfonti hl12b); Base:10 -*-
;;;; *-* File: Titanic: /usr/users/eksl/systems/utils/dev/distance.lisp *-*
;;;; *-* Last-edit: Sunday, July 2, 1995  21:37:48; Edited-By: anderson *-* 
;;;; *-* Machine: Christa (Explorer II, Microcode 489) *-*
;;;; *-* Software: TI Common Lisp System 6.49 *-*
;;;; *-* Lisp: TI Common Lisp System 6.49  *-*

;;;; **************************************************************************
;;;; **************************************************************************
;;;; *                                                                        *
;;;; *                      Distance Conversion Functions                     *
;;;; *                                                                        *
;;;; **************************************************************************
;;;; **************************************************************************
;;;
;;; Written by: Mike Greenberg
;;;             Experimental Knowledge Systems Laboratory
;;;             Paul R. Cohen, Principal Investigator
;;;             David L. Westbrook, Systems Manager
;;;             David M. Hart, Laboratory Manager
;;;             Department of Computer Science
;;;             University of Massachusetts
;;;             Amherst, Massachusetts 01003.
;;;
;;; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
;;;
;;;  07-02-95 Copied out of Phoenix.  (anderson)
;;;
;;; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
;;; --*--

(in-package :eksl-utilities)

(export '(*meters-per-chain* 
	   *km-per-mile* 
	   *feet-per-km* 
	   chains->meters 
	   chains->km 
	   miles->km 
	   km->miles 
	   km/hour->meters/second 
	   chains/hour->meters/minute 
	   chains/hour->meters/second 
	   km->feet))

;;; --*--
;;; ***************************************************************************

(defconstant *meters-per-chain* 20.12)
(defconstant *km-per-mile* 1.6093)
(defconstant *feet-per-km* 3280.8)

(defun chains->meters (chains)
  (* chains *meters-per-chain*))

(defun chains->km (chains)
  (/ (* chains *meters-per-chain*) 1000.0))

(defun miles->km (miles)
  (* miles *km-per-mile*))

(defun km->miles (km)
  (* km (/ *km-per-mile*)))

(defun km/hour->meters/second (km)
  (* km (/ 1000.0 3600.0)))

(defun chains/hour->meters/minute (n)
  (* n *meters-per-chain*  (/ 1.0 60)))

(defun chains/hour->meters/second (n)
  (* n *meters-per-chain*  (/ 1.0 60 60)))

(defun km->feet (km)
  (* km *feet-per-km*))

;;; ***************************************************************************
;;; EOF
