;;;; -*- Mode: Common-Lisp; Package: EKSL-UTILITIES; Base: 10 -*-
;;;; *-* File: /usr/users/eksl/systems/utils/print-utils.lisp *-*
;;;; *-* Last-Edit: Saturday, May 6, 1995  12:29:15; Edited-By: anderson *-*
;;;; *-* Machine: Earhart (Alpha) *-*
;;;; *-* Software: Harlequin Common Lisp 3.2 *-*
;;;;
;;;; **************************************************************************
;;;; **************************************************************************
;;;; *                                                                        *
;;;; *                       UTILITIES TO PRINT OBJECTS                       *
;;;; *                                                                        *
;;;; **************************************************************************
;;;; **************************************************************************
;;;
;;; Written by: Scott D. Anderson
;;;             Department of Computer Science
;;;             University of Massachusetts
;;;             Amherst, Massachusetts 01003.
;;;
;;; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
;;;
;;;  05-06-95 File Created.  (anderson)
;;;
;;; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *

(in-package :EKSL-UTILITIES)

(proclaim '(optimize (speed 3) (safety 1)))

(export '(print-hash-table print-array))

(defun print-hash-table (table &optional (stream *standard-output*))
  "Print a hash table to a stream, defaulting to *standard-output*"
  (maphash #'(lambda (key value)
	       (format stream "~&~S = ~S" key value))
	   table))


(defun print-array (array &optional long-form? (stream *standard-output*))
  "Prints `array' to `stream' \(which defaults to *standard-output*\).  If
`long-form?' is nil \(the default\), this is the same as binding *print-array*
to true.  If `long-form?' is true, this prints each element of the array on its
own line with its index."
  (if long-form?
      (dotimes (i (length array))
	(format stream "~%~D: ~S" i (aref array i)))
      (let ((*print-array* t))
	(print array))))


;;; ***************************************************************************
;;; *                              End of File                                *
;;; ***************************************************************************