;;; -*- Mode:Common-Lisp; Base:10 -*-
;;;; *-* Last-edit: Tuesday, December 13, 1994  16:21:31; Edited-By: anderson *-* 

;;; The following code was mailed to me by Harlequin. (Anderson)

(in-package "SYS")

(defun output-object (object &optional (currlevel 0))
  (cond ((lw-xp::xp-structure-p *output-stream*)
         (lw-xp::write+ object *output-stream*))
        (*print-pretty*
         (lw-xp::maybe-initiate-xp-printing
          #'(lambda (s o) (lw-xp::write+ o s)) *output-stream* object))
        ((ratiop object) (print-object object *output-stream*))
        (t (output-plain-object object currlevel))))

(sys::without-warning-on-redefinition
 (defmethod print-object ((r ratio) stream) 
   (let ((*output-stream* stream))
     ;; bind internal *output-stream* to allow user to call method
     ;; directly, but user calling is not allowed by standard.
     (output-ratio r))
   r))

(in-package :cl-user)

(defparameter *print-rationals-as-floats?* nil
  "When true, a rational is printed as a float, so that it is readable, but it
is followed with an R, so that the user knows it's really a rational.  This
should probably be turned off when *print-readably* is true.")

(sys::without-warning-on-redefinition
 (defmethod print-object :around ((r ratio) stream)
   (if (and *print-rationals-as-floats?* (not (integerp r)))
       (format stream "~fR" r)
     (call-next-method r stream))
   r))
